summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--Makefile9
-rw-r--r--libalpm/hooks/60-mkinitcpio-remove.hook16
-rw-r--r--libalpm/hooks/90-mkinitcpio-install.hook12
-rw-r--r--libalpm/scripts/mkinitcpio-install44
-rw-r--r--libalpm/scripts/mkinitcpio-remove39
-rw-r--r--mkinitcpio.d/hook.preset14
6 files changed, 133 insertions, 1 deletions
diff --git a/Makefile b/Makefile
index 94c90de..9ef0f6a 100644
--- a/Makefile
+++ b/Makefile
@@ -18,7 +18,9 @@ DIRS = \
/usr/share/man/man1 \
/usr/share/mkinitcpio \
/usr/lib/systemd/system/shutdown.target.wants \
- /usr/lib/tmpfiles.d
+ /usr/lib/tmpfiles.d \
+ /usr/share/libalpm/hooks \
+ /usr/share/libalpm/scripts
BASH_SCRIPTS = \
mkinitcpio \
@@ -70,6 +72,11 @@ install: all
ln -s mkinitcpio $(DESTDIR)/usr/share/bash-completion/completions/lsinitcpio
install -m644 shell/zsh-completion $(DESTDIR)/usr/share/zsh/site-functions/_mkinitcpio
+ install -m644 libalpm/hooks/90-mkinitcpio-install.hook $(DESTDIR)/usr/share/libalpm/hooks/90-mkinitcpio-install.hook
+ install -m755 libalpm/scripts/mkinitcpio-install $(DESTDIR)/usr/share/libalpm/scripts/mkinitcpio-install
+ install -m644 libalpm/hooks/60-mkinitcpio-remove.hook $(DESTDIR)/usr/share/libalpm/hooks/60-mkinitcpio-remove.hook
+ install -m755 libalpm/scripts/mkinitcpio-remove $(DESTDIR)/usr/share/libalpm/scripts/mkinitcpio-remove
+
doc: $(MANPAGES)
man/%: man/%.txt Makefile
a2x -d manpage \
diff --git a/libalpm/hooks/60-mkinitcpio-remove.hook b/libalpm/hooks/60-mkinitcpio-remove.hook
new file mode 100644
index 0000000..ab71ed6
--- /dev/null
+++ b/libalpm/hooks/60-mkinitcpio-remove.hook
@@ -0,0 +1,16 @@
+[Trigger]
+Type = File
+Operation = Remove
+Target = usr/lib/modules/*/vmlinuz
+
+[Trigger]
+Type = Package
+Operation = Remove
+Target = mkinitcpio
+Target = mkinitcpio-git
+
+[Action]
+Description = Removing linux initcpios...
+When = PreTransaction
+Exec = /usr/share/libalpm/scripts/mkinitcpio-remove
+NeedsTargets
diff --git a/libalpm/hooks/90-mkinitcpio-install.hook b/libalpm/hooks/90-mkinitcpio-install.hook
new file mode 100644
index 0000000..48e6a1e
--- /dev/null
+++ b/libalpm/hooks/90-mkinitcpio-install.hook
@@ -0,0 +1,12 @@
+[Trigger]
+Type = File
+Operation = Install
+Operation = Upgrade
+Target = usr/lib/modules/*/vmlinuz
+Target = usr/lib/initcpio/*
+
+[Action]
+Description = Updating linux initcpios...
+When = PostTransaction
+Exec = /usr/share/libalpm/scripts/mkinitcpio-install
+NeedsTargets
diff --git a/libalpm/scripts/mkinitcpio-install b/libalpm/scripts/mkinitcpio-install
new file mode 100644
index 0000000..d2e5041
--- /dev/null
+++ b/libalpm/scripts/mkinitcpio-install
@@ -0,0 +1,44 @@
+#!/bin/bash -e
+
+args=()
+all=0
+
+while read -r line; do
+ if [[ $line != */vmlinuz ]]; then
+ # triggers when it's a change to usr/lib/initcpio/*
+ all=1
+ continue
+ fi
+
+ if ! read -r pkgbase > /dev/null 2>&1 < "${line%/vmlinuz}/pkgbase"; then
+ # if the kernel has no pkgbase, we skip it
+ continue
+ fi
+
+ preset="/etc/mkinitcpio.d/${pkgbase}.preset"
+ if [[ ! -e $preset ]]; then
+ if [[ -e $preset.pacsave ]]; then
+ # move the pacsave to the template
+ mv "${preset}.pacsave" "$preset"
+ else
+ # create the preset from the template
+ sed "s|%PKGBASE%|${pkgbase}|g" /usr/share/mkinitcpio/hook.preset \
+ | install -Dm644 /dev/stdin "$preset"
+ fi
+ fi
+
+ # always install the kernel
+ install -Dm644 "${line}" "/boot/vmlinuz-${pkgbase}"
+
+ # compound args for each kernel
+ args+=(-p "${pkgbase}")
+done
+
+if (( all )) && compgen -G /etc/mkinitcpio.d/"*.preset" > /dev/null; then
+ # change to use all presets
+ args=(-P)
+fi
+
+if (( ${#args[@]} )); then
+ mkinitcpio "${args[@]}"
+fi
diff --git a/libalpm/scripts/mkinitcpio-remove b/libalpm/scripts/mkinitcpio-remove
new file mode 100644
index 0000000..86838e4
--- /dev/null
+++ b/libalpm/scripts/mkinitcpio-remove
@@ -0,0 +1,39 @@
+#!/bin/bash -e
+
+package=0
+
+while read -r line; do
+ if [[ $line != */vmlinuz ]]; then
+ # triggers when it's a change to usr/lib/initcpio/*
+ package=1
+ continue
+ fi
+
+ if ! read -r pkgbase > /dev/null 2>&1 < "${line%/vmlinuz}/pkgbase"; then
+ # if the kernel has no pkgbase, we skip it
+ continue
+ fi
+
+ # remove the actual kernel and images for the package being removed
+ kernel="/boot/vmlinuz-${pkgbase}"
+ preset="/etc/mkinitcpio.d/${pkgbase}.preset"
+ initramfs="/boot/initramfs-${pkgbase}.img"
+ fallback_initramfs="/boot/initramfs-${pkgbase}-fallback.img"
+ if [[ -e $kernel ]]; then
+ # remove the installed kernel
+ rm $kernel
+ fi
+ if [[ -e $preset ]]; then
+ # remove the preset
+ rm $preset
+ fi
+ if [[ -e $initramfs && -e $fallback_initramfs ]]; then
+ # remove the images
+ rm $initramfs $fallback_initramfs
+ fi
+done
+
+if (( package )) && compgen -G /etc/mkinitcpio.d/"*.preset" > /dev/null; then
+ # remove all presets
+ rm /etc/mkinitcpio.d/*.preset
+fi
diff --git a/mkinitcpio.d/hook.preset b/mkinitcpio.d/hook.preset
new file mode 100644
index 0000000..66709a8
--- /dev/null
+++ b/mkinitcpio.d/hook.preset
@@ -0,0 +1,14 @@
+# mkinitcpio preset file for the '%PKGBASE%' package
+
+ALL_config="/etc/mkinitcpio.conf"
+ALL_kver="/boot/vmlinuz-%PKGBASE%"
+
+PRESETS=('default' 'fallback')
+
+#default_config="/etc/mkinitcpio.conf"
+default_image="/boot/initramfs-%PKGBASE%.img"
+#default_options=""
+
+#fallback_config="/etc/mkinitcpio.conf"
+fallback_image="/boot/initramfs-%PKGBASE%-fallback.img"
+fallback_options="-S autodetect"